/*
 * Copyright (c) 1999 Apple Computer, Inc. All rights reserved.
 *
 * @APPLE_LICENSE_HEADER_START@
 * 
 * "Portions Copyright (c) 1999 Apple Computer, Inc.  All Rights
 * Reserved.  This file contains Original Code and/or Modifications of
 * Original Code as defined in and that are subject to the Apple Public
 * Source License Version 1.0 (the 'License').  You may not use this file
 * except in compliance with the License.  Please obtain a copy of the
 * License at http://www.apple.com/publicsource and read it before using
 * this file.
 * 
 * The Original Code and all software distributed under the License are
 * distributed on an 'AS IS' basis, WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, AND APPLE HEREBY DISCLAIMS ALL SUCH WARRANTIES,
 * INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT.  Please see the
 * License for the specific language governing rights and limitations
 * under the License."
 * 
 * @APPLE_LICENSE_HEADER_END@
 */
/* compiled bitmaps */

typedef struct tiff {
		char	*tif_name;				/* name of open file */
		long	tif_row;				/* current scanline */
		char	*tif_rawdata;			/* raw data buffer */
		long	tif_rawdatasize;		/* # of bytes in raw data buffer */
		char	*tif_rawcp; 			/* current spot in raw buffer */
		long	tif_rawcc;				/* bytes unread from raw buffer */
		int 	tif_curstrip;			/* current strip for read/write */
		long	tif_curoff; 			/* current offset for read/write */
} TIFF;



struct bitmap {
		short packed;
		short bytes_per_plane;
		short bytes_per_row;
		short bits_per_pixel;
		short width, height;
		short plane_len[2];
		unsigned char *plane_data[2];
};


